var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { useState } from 'react';
import { Box, darken, Icon, IconButton } from '@mui/material';
import { usePersistentState } from 'react-persistent-state/build';
import { colorError, colorInfo, colorSuccess, colorWarning } from '../_core/style/color';
var height = function (dense) { return dense ? 44 : 52; };
export var Alert = function (_a) {
    var type = _a.type, dense = _a.dense, hidden = _a.hidden, icon = _a.icon, action = _a.action, deletable = _a.deletable, persistentDelete = _a.persistentDelete, sx = _a.sx, gutterBottom = _a.gutterBottom, children = _a.children, dangerouslySetInnerHTML = _a.dangerouslySetInnerHTML, props = __rest(_a, ["type", "dense", "hidden", "icon", "action", "deletable", "persistentDelete", "sx", "gutterBottom", "children", "dangerouslySetInnerHTML"]);
    var _b = usePersistentState(true, props.id || 'alert'), isPersistentVisible = _b[0], setPersistentIsVisible = _b[1];
    var _c = useState(true), isVisible = _c[0], setIsVisible = _c[1];
    var getIconFromType = function () {
        switch (type) {
            case 'info':
                return 'info';
            case 'error':
                return 'error';
            case 'warning':
                return 'warning';
            case 'success':
                return 'check_circle';
            default:
                return 'info';
        }
    };
    return (React.createElement(Box, __assign({}, props, { sx: __assign(__assign(__assign(__assign({ 
            // paddingLeft: t.spacing(2),
            // paddingRight: t.spacing(2),
            // [t.breakpoints.up('sm')]: {
            //   paddingLeft: t.spacing(3),
            //   paddingRight: t.spacing(3),
            // },
            transition: function (t) { return t.transitions.create('all'); }, 
            // @ts-ignore
            minHeight: height(props.dense), display: 'flex', alignItems: 'center', overflow: 'hidden', borderRadius: '4px', 
            // @ts-ignore
            paddingLeft: dense ? 1 : 2, paddingRight: dense ? 1 : 2 }, ({
            success: {
                background: 'rgba(50, 255, 150, .08)',
                color: darken(colorSuccess, .1),
            },
            info: {
                background: 'rgba(50, 200, 255, .08)',
                color: darken(colorInfo, .1),
            },
            error: {
                background: 'rgba(255, 0, 0, .08)',
                color: darken(colorError, .1),
            },
            warning: {
                background: 'rgba(255, 128, 0, .08)',
                color: darken(colorWarning, .1),
            },
        })[type]), (hidden || !isVisible || (persistentDelete && !isPersistentVisible)) && {
            minHeight: '0 !important',
            height: '0 !important',
            opacity: '0 !important',
            margin: '0 !important',
        }), gutterBottom && {
            mb: 1
        }), sx) }),
        React.createElement(Icon, { sx: {
                mr: dense ? 0 : 1,
                height: height(dense) + "px !important",
                display: 'flex',
                alignItems: 'center',
                alignSelf: 'flex-start',
            } }, icon ? icon : getIconFromType()),
        React.createElement(Box, { children: children, dangerouslySetInnerHTML: dangerouslySetInnerHTML, sx: {
                flex: 1,
                py: dense ? 1 : 2,
                px: 1,
            } }),
        action || deletable && (React.createElement(Box, { sx: {
                textAlign: 'right',
                mt: 1,
                ml: 0,
                mb: 1,
                mr: -1
            } },
            action,
            deletable &&
                React.createElement(IconButton, { onClick: function () {
                        setIsVisible(false);
                        if (persistentDelete)
                            setPersistentIsVisible(false);
                    }, size: "large" },
                    React.createElement(Icon, null, "clear"))))));
};
