var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { Box, CircularProgress, Icon } from '@mui/material';
import { colorError, colorSuccess, colorWarning } from '../_core/style/color';
export var Fender = function (_a) {
    var children = _a.children, icon = _a.icon, _b = _a.iconSize, iconSize = _b === void 0 ? 100 : _b, _c = _a.type, type = _c === void 0 ? 'empty' : _c, title = _a.title, description = _a.description, sx = _a.sx, props = __rest(_a, ["children", "icon", "iconSize", "type", "title", "description", "sx"]);
    var getIcon = function () {
        if (icon)
            return renderIcon(icon);
        switch (type) {
            case 'empty':
                return renderIcon('do_not_disturb');
            case 'error':
                return renderIcon('error_outline');
            case 'success':
                return renderIcon('check_circle_outline');
            case 'warning':
                return renderIcon('warning');
            case 'loading':
                return React.createElement(CircularProgress, { size: iconSize - 10 });
        }
    };
    var renderIcon = function (name) { return React.createElement(Icon, { sx: { fontSize: iconSize + "px !important" } }, name); };
    return (React.createElement(Box, __assign({}, props, { sx: __assign({ transition: function (t) { return t.transitions.create('all'); }, display: 'flex', textAlign: 'center', alignItems: 'center', justifyContent: 'center' }, sx) }),
        React.createElement("div", null,
            React.createElement(Box, { sx: __assign({ height: iconSize + 10, mt: 1, lineHeight: 1 }, ({
                    error: {
                        color: colorError
                    },
                    empty: {
                        color: function (t) { return t.palette.text.disabled; }
                    },
                    warning: {
                        color: colorWarning
                    },
                    success: {
                        color: colorSuccess
                    }
                })[type]) }, getIcon()),
            React.createElement(Box, { sx: { mt: 1 } },
                title && React.createElement(Box, { sx: { fontSize: 24 } }, title),
                description && React.createElement(Box, null, description),
                children))));
};
