var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import { useContext } from 'react';
export var GlobalProgressContext = React.createContext({});
export var progressbarAnimationDuration = 400;
var GlobalProgressProvider = /** @class */ (function (_super) {
    __extends(GlobalProgressProvider, _super);
    function GlobalProgressProvider() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.timeouts = [];
        _this.start = function (steps) {
            if (steps === void 0) { steps = 1; }
            _this.clearTimeouts();
            _this.setState({
                started: true,
                currentStep: 0,
                steps: steps,
            });
        };
        _this.promisesWithProgress = function () {
            var promises = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                promises[_i] = arguments[_i];
            }
            _this.start(promises.length);
            return promises.map(function (p) { return p
                .then(function (_) {
                _this.next();
                return _;
            })
                .catch(function (_) {
                _this.stop();
                return Promise.reject(_);
            }); });
        };
        _this.stop = function () {
            _this.setState({
                started: false,
                currentStep: 0,
            });
        };
        _this.complete = function () {
            if (_this.state.started) {
                _this.setState(function (state) { return ({
                    currentStep: state.steps,
                }); }, _this.stopHandlingAnimation);
            }
        };
        _this.next = function () {
            if (_this.state.started) {
                _this.setState(function (state) { return ({
                    currentStep: Math.min(state.currentStep + 1, state.steps),
                }); }, function () { return _this.state.currentStep === _this.state.steps && _this.stopHandlingAnimation(); });
            }
        };
        _this.state = {
            currentStep: 0,
            steps: 1,
            started: false,
            progressStart: _this.start,
            progressStop: _this.stop,
            progressComplete: _this.complete,
            progressNext: _this.next,
            promisesWithProgress: _this.promisesWithProgress,
        };
        return _this;
    }
    GlobalProgressProvider.prototype.render = function () {
        return (React.createElement(GlobalProgressContext.Provider, { value: this.state }, this.props.children));
    };
    GlobalProgressProvider.prototype.componentWillUnmount = function () {
        this.clearTimeouts();
    };
    GlobalProgressProvider.prototype.stopHandlingAnimation = function () {
        var _this = this;
        this.setTimeout(function () { return _this.setState({ started: false }); }, progressbarAnimationDuration);
        this.setTimeout(function () { return _this.setState({ currentStep: 0 }); }, progressbarAnimationDuration * 2);
    };
    GlobalProgressProvider.prototype.setTimeout = function (fn, duration) {
        this.timeouts.push(window.setTimeout(fn, duration));
    };
    GlobalProgressProvider.prototype.clearTimeouts = function () {
        this.timeouts.map(clearTimeout);
        this.timeouts = [];
    };
    return GlobalProgressProvider;
}(React.Component));
export default GlobalProgressProvider;
export var useGlobalProgress = function () {
    var _a = useContext(GlobalProgressContext), progressStart = _a.progressStart, progressStop = _a.progressStop, progressComplete = _a.progressComplete, progressNext = _a.progressNext, promisesWithProgress = _a.promisesWithProgress;
    return {
        progressStart: progressStart,
        progressStop: progressStop,
        progressComplete: progressComplete,
        progressNext: progressNext,
        promisesWithProgress: promisesWithProgress,
    };
};
export var useGlobalProgressState = function () {
    var _a = useContext(GlobalProgressContext), currentStep = _a.currentStep, steps = _a.steps, started = _a.started;
    return {
        currentStep: currentStep,
        steps: steps,
        started: started,
    };
};
export var withGlobalProgress = function (Component) { return function (props) { return (React.createElement(GlobalProgressContext.Consumer, null, function (other /*WithProgress*/) { return React.createElement(Component, __assign({}, props, other)); })); }; };
