import { ReactNode } from 'react';
import { SnackbarProps } from '@mui/material';
export interface ToastOptions extends Pick<SnackbarProps, 'autoHideDuration' | 'action'> {
    onClose?: (event: any) => void;
    keepOpenOnClickAway?: boolean;
}
export interface WithToast {
    toastError: (m: string, options?: ToastOptions) => void;
    toastSuccess: (m: string, options?: ToastOptions) => void;
    toastWarning: (m: string, options?: ToastOptions) => void;
    toastInfo: (m: string, options?: ToastOptions) => void;
    toastLoading: (m: string, options?: ToastOptions) => void;
}
export interface ToastProviderProps {
    children: ReactNode;
    vertical?: 'top' | 'bottom';
    horizontal?: 'left' | 'center' | 'right';
}
export declare const ToastProvider: ({ children, vertical, horizontal }: ToastProviderProps) => JSX.Element;
export declare const useToast: () => WithToast;
export declare const withToast: (Component: any) => (props: any) => JSX.Element;
