import * as React from 'react';
import { useState } from 'react';
import { Box, Collapse, Icon, IconButton } from '@mui/material';
import { Pre } from './Pre/Pre';
import { Panel } from '../../Panel';
var parseComponentCode = function (code) { return code.replace(/\n\s*\/\/\s*@ts-ignore\s*?\n/, '\n'); };
export var Demo = function (_a) {
    var Component = _a.component, raw = _a.raw, reloadable = _a.reloadable;
    var _b = useState(false), codeOpened = _b[0], setCodeOponed = _b[1];
    var _c = useState(true), show = _c[0], setShow = _c[1];
    var _d = useState(undefined), containerHeight = _d[0], setContainerHeight = _d[1];
    var componentContainer = React.createRef();
    var reload = function () {
        // Manually handle container height is relevant when to prevent the
        // container to blink when the content is animated.
        if (!containerHeight) {
            setContainerHeight(componentContainer.current.offsetHeight - 32);
        }
        setShow(false);
        setTimeout(function () { return setShow(true); });
        setTimeout(function () { return setContainerHeight(undefined); });
    };
    return (React.createElement(Panel, null,
        React.createElement(Box, { sx: {
                mt: 1,
                mr: 2,
                mb: 1 / 2,
                ml: 2,
                display: 'flex',
                alignItems: 'center',
                justifyContent: 'flex-end'
            } },
            reloadable &&
                React.createElement(IconButton, { disabled: !show, onClick: reload, size: "large" },
                    React.createElement(Icon, null, "refresh")),
            React.createElement(IconButton, { color: codeOpened ? 'primary' : undefined, onClick: function () { return setCodeOponed(!codeOpened); }, size: "large" },
                React.createElement(Icon, null, "code"))),
        React.createElement(Collapse, { in: codeOpened, unmountOnExit: true },
            React.createElement(Pre, { raw: parseComponentCode(raw), style: { margin: 0, borderRadius: 0 } })),
        React.createElement(Box, { sx: {
                p: 2,
                m: 1,
                background: function (t) { return t.palette.background.paper; },
            }, ref: componentContainer, style: { height: containerHeight } }, show && React.createElement(Component, null))));
};
