"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useLayoutContext = exports.LayoutProvider = void 0;
var React = __importStar(require("react"));
var react_1 = require("react");
// import debounce from 'lodash.debounce'
var LayoutContext = (0, react_1.createContext)({});
var LayoutProvider = function (_a) {
    var title = _a.title, _b = _a.mobileBreakpoint, mobileBreakpoint = _b === void 0 ? 700 : _b, children = _a.children;
    var _c = (0, react_1.useState)(false), isMobileSidebarOpened = _c[0], setIsMobileSidebarOpened = _c[1];
    var _d = (0, react_1.useState)(getWidth()), mobileWidth = _d[0], setMobileWidth = _d[1];
    var openMobileSidebar = function () { return setIsMobileSidebarOpened(true); };
    var closeMobileSidebar = function () { return setIsMobileSidebarOpened(false); };
    var toggleMobileSidebar = function () { return setIsMobileSidebarOpened(!isMobileSidebarOpened); };
    (0, react_1.useEffect)(function () {
        window.addEventListener('resize', function () { return setMobileWidth(getWidth()); });
        // window.addEventListener('resize', debounce(() => setMobileWidth(getWidth()), 600))
    }, []);
    return (React.createElement(LayoutContext.Provider, { value: {
            isMobileSidebarOpened: isMobileSidebarOpened,
            openMobileSidebar: openMobileSidebar,
            closeMobileSidebar: closeMobileSidebar,
            toggleMobileSidebar: toggleMobileSidebar,
            title: title,
            isMobileWidth: mobileWidth < mobileBreakpoint,
        } }, children));
};
exports.LayoutProvider = LayoutProvider;
function getWidth() {
    return window.innerWidth;
}
var useLayoutContext = function () {
    return (0, react_1.useContext)(LayoutContext);
};
exports.useLayoutContext = useLayoutContext;
//# sourceMappingURL=LayoutContext.js.map