"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SidebarItem = void 0;
var React = __importStar(require("react"));
var material_1 = require("@mui/material");
var createStyles_1 = __importDefault(require("@mui/styles/createStyles"));
var makeStyles_1 = __importDefault(require("@mui/styles/makeStyles"));
var classnames_1 = __importDefault(require("classnames"));
var styles_1 = require("@mui/material/styles");
var LayoutContext_1 = require("../LayoutContext");
var useStyles = (0, makeStyles_1.default)(function (t) { return (0, createStyles_1.default)({
    root: {
        transition: t.transitions.create('all'),
        display: 'flex',
        alignItems: 'center',
        textDecoration: 'inherit',
        paddingRight: t.spacing(1),
        paddingLeft: t.spacing(2),
        color: t.palette.text.primary,
        minHeight: 32,
        marginTop: t.spacing(1 / 8),
        marginBottom: t.spacing(1 / 8),
        marginRight: t.spacing(1),
        marginLeft: t.spacing(1),
        borderRadius: 42,
    },
    rootLarge: {
        minHeight: 38,
    },
    rootClickable: {
        cursor: 'pointer',
        '&:hover': {
            background: 'rgba(0, 0, 0, .05)',
        },
    },
    rootActive: {
        color: t.palette.primary.main,
        background: (0, styles_1.alpha)(t.palette.primary.main, .16),
    },
    i: {
        // color: t.palette.text.secondary,
        textAlign: 'center',
        marginRight: t.spacing(2),
    },
    label: {
        whiteSpace: 'nowrap',
        overflow: 'hidden',
        textOverflow: 'ellipsis',
        display: 'flex',
        alignItems: 'center',
        flex: 1,
        fontSize: t.typography.fontSize,
        fontWeight: t.typography.fontWeightMedium,
    },
}); });
var SidebarItem = function (_a) {
    var children = _a.children, icon = _a.icon, className = _a.className, active = _a.active, large = _a.large, other = __rest(_a, ["children", "icon", "className", "active", "large"]);
    var closeMobileSidebar = (0, LayoutContext_1.useLayoutContext)().closeMobileSidebar;
    var classes = useStyles();
    var getClassName = function (clickable) {
        if (clickable === void 0) { clickable = true; }
        return (0, classnames_1.default)(className, classes.root, active && classes.rootActive, clickable && classes.rootClickable, large && classes.rootLarge);
    };
    return (React.createElement("div", { onClick: closeMobileSidebar },
        React.createElement("div", __assign({}, other, { className: getClassName(true) }),
            React.createElement(React.Fragment, null,
                icon && ((typeof icon === 'string')
                    ? React.createElement(material_1.Icon, { className: classes.i }, icon)
                    : React.createElement("div", { className: (0, classnames_1.default)(classes.i) }, icon)),
                React.createElement("span", { className: classes.label }, children)))));
};
exports.SidebarItem = SidebarItem;
//# sourceMappingURL=SidebarItem.js.map